bool salvaOpzioni()
{
  char salvanome[256];
  strcpy(salvanome, ROOTDIR);
  strcat(salvanome, "settings.ini");
  fstream file(salvanome, ios::out | ios::binary);
  if (file.is_open())
  {
    file.seekg(0, ios::beg);
    file.write(mkl32(opzione.startLvl), 4);
    file.write(mkl32(opzione.difficolta), 4);
    file.write(mkl32(opzione.sonoro), 4);
    file.write(mkl32(opzione.autosave), 4);
    file.write(mkl32(opzione.volumeEffetti), 4);
    file.write(mkl32(opzione.mouse), 4);
    file.write(mkl32(opzione.volumeMusica), 4);
    file.write(mkl32(opzione.fullscreen), 4);
    file.write(mkl32(opzione.panscan), 4);
    file.write(mkl32(opzione.lq), 4);
    file.write(mkl32(opzione.maxfps), 4);
    file.close();
    cout << "[I] Settings successfully saved on disk!\n";
    return true;
  }
  else
  {
    cerr << "[E] Unable to open file to salvaOpzioni()!\n";
    cerr << "    Check if ~/.ppong/settings.ini (Linux)\n";
    cerr << "    or %USERPROFILE%\\ppong\\settings.ini (Windows) exists!\n";
    msg("Errore! La configurazione viene persa quando si esce!", 10000);
    return false;
  }
}

bool caricaOpzioni()
{
  char salvanome[256];
  strcpy(salvanome, ROOTDIR);
  strcat(salvanome, "settings.ini");
  fstream file(salvanome, ios::in | ios::binary);
  if (file.is_open())
  {
    file.seekg(0, ios::beg); char t[4];
    file.read(t, 4); opzione.startLvl = cvl32(t);
    file.read(t, 4); opzione.difficolta = cvl32(t);
    file.read(t, 4); opzione.sonoro = cvl32(t);
    file.read(t, 4); opzione.autosave = cvl32(t);
    file.read(t, 4); opzione.volumeEffetti = cvl32(t);
    file.read(t, 4); opzione.mouse = cvl32(t);
    file.read(t, 4); opzione.volumeMusica = cvl32(t);
    file.read(t, 4); opzione.fullscreen = cvl32(t);
    file.read(t, 4); opzione.panscan = cvl32(t);
    file.read(t, 4); opzione.lq = cvl32(t);
    file.read(t, 4); opzione.maxfps = cvl32(t);
    file.close();
    return true;
  }
  else
  {
    clog << "[W] Unable to open file to caricaOpzioni()!\n";
    clog << "    Check if ~/.ppong/settings.ini (Linux)\n";
    clog << "    or %USERPROFILE%\\ppong\\settings.ini (Windows) exists!\n";
    return false;
  }
}

bool opzioni()
{
  #define OPT_MENU_COLOR 0xAAAAAA
  #define OPT_LABEL_COLOR 0x00FF00
  #define OPT_SELECTED_COLOR 0xFFFF00
  #define OPT_VALUE_COLOR 0x00FFFF

  #define N_OPZIONI 12

  boxColor(schermo, 0, 0, 639, 479, 0x000000FF);
  short selected = 1;
  char label[N_OPZIONI][25] = {0};
  long data[N_OPZIONI];
  strcpy(label[0], "Record attuale"); char t[4];
  filelvl.seekg(0, ios::beg);
  filelvl.read(t, 4); data[0] = cvl32(t);
  strcpy(label[1], "Livello di partenza"); data[1] = opzione.startLvl + 1;
  strcpy(label[2], "Difficolta'"); data[2] = opzione.difficolta;
  strcpy(label[3], "Salvataggio automatico"); data[3] = opzione.autosave;
  strcpy(label[4], "Controllo mouse"); data[4] = opzione.mouse;
  strcpy(label[5], "Suono"); data[5] = opzione.sonoro;
  strcpy(label[6], "Volume musica"); data[6] = opzione.volumeMusica;
  strcpy(label[7], "Volume effetti sonori"); data[7] = opzione.volumeEffetti;
  strcpy(label[8], "Modalita' 4:3"); data[8] = opzione.panscan;
  strcpy(label[9], "Schermo intero"); data[9] = opzione.fullscreen;
  strcpy(label[10], "Bassa qualita'"); data[10] = opzione.lq;
  strcpy(label[11], "Max FPS"); data[11] = 1000 / opzione.maxfps;

  font(0, 20, "Opzioni di gioco", 0xFF0000);
  font(0, 40, "INVIO per salvare, ESC per annullare", OPT_MENU_COLOR);
  font(0,  60, "Su/giu' per selezionare l'opzione", OPT_MENU_COLOR);
  font(0,  80, "sinistra/destra per cambiarne il valore", OPT_MENU_COLOR);
  font(0, 100, "Per rendere effettive alcune modifiche,", 0xFF9100);
  font(0, 120, "potrebbe essere necessario riavviare il programma", 0xFF9100);

  do
  {
    SDL_Delay(50); SDL_PumpEvents();
    if (premuto(SDLK_ESCAPE)) return false;
    if (premuto(SDLK_RETURN))
    {
      opzione.startLvl = data[1] - 1;
      opzione.difficolta = data[2];
      opzione.sonoro = data[5];
      opzione.autosave = data[3];
      opzione.volumeEffetti = data[7];
      opzione.mouse = data[4];
      opzione.volumeMusica = data[6];
      opzione.panscan = data[8];
      opzione.fullscreen = data[9];
      opzione.lq = data[10];
      opzione.maxfps = 1000 / data[11];
      if (salvaOpzioni()) return true; else return false;
    }
    if (premuto(SDLK_DOWN)) { selected++; suona(MENU_SOUND); }
    if (premuto(SDLK_UP)) { selected--; suona(MENU_SOUND); }
    if (premuto(SDLK_RIGHT)) { data[selected]++; suona(MENU_SOUND); }
    if (premuto(SDLK_LEFT)) { data[selected]--; suona(MENU_SOUND); }
    if (selected < 1) { selected = 1; suona(MENU_ERROR_SOUND); }
    if (selected > (N_OPZIONI - 1)) { selected = N_OPZIONI - 1; suona(MENU_ERROR_SOUND); }

    for (short v = 0; v < N_OPZIONI; v++)
    {
      if (v == 3 || v == 4 || v == 5 || v == 8 || v == 9 || v == 10)
        { if (data[v] < 0) data[v] = 0; if (data[v] > 1) data[v] = 1; }
      else if (v == 2)
        { if (data[v] > 6) data[v] = 6; if (data[v] < 1) data[v] = 1; }
      else if (v == 6 || v == 7)
        { if (data[v] < 0) data[v] = 0; if (data[v] > MIX_MAX_VOLUME - 1) data[v] = MIX_MAX_VOLUME - 1; }
      else
        { if (data[v] < 1) data[v] = 1; }

      Uint32 colore;
      if (v == selected) colore = OPT_SELECTED_COLOR;
        else colore = OPT_LABEL_COLOR;
      font(200, 140 + v * 16, label[v], colore);
      if (v == 3 || v == 4 || v == 5 || v == 8 || v == 9 || v == 10)
      {
        font(410, 140 + v * 16, data[v] ? "Acceso" : "Spento", OPT_VALUE_COLOR);
      }
      else if (v == 6 || v == 7)
      {
        font(410, 140 + v * 16, (data[v] == MIX_MAX_VOLUME - 1) ? "Massimo" : itoa(data[v]), OPT_VALUE_COLOR);
      }
      else
      {
        font(410, 140 + v * 16, itoa(data[v]), OPT_VALUE_COLOR);
      }
    }
    SDL_Flip(schermo);
    boxColor(schermo, 0, 140, 639, 479, 0x000000FF);

  } while (true);

}

bool caricafont()
{
  bool r = true;
  carattere = TTF_OpenFont("data/font.ttf", FONTH - 1); /* -1 compensa i caratteri oversize*/

  fstream file("data/9x15.fnt", ios::in | ios::binary);
  if (file.is_open())
  {
    static char fontDef[7680];
    file.read(fontDef, 7680);
    gfxPrimitivesSetFont(fontDef, FONTW, FONTH);
    file.close();
  }
  else
  {
    clog << "[W] Unable to load the simple raw font" << endl;
    r = false;
  }

  if (carattere == NULL) { clog << "[W] Unable to load the TTF font!" << endl; r = false; }

  return r;
}

bool caricaIcone()
{
  SDL_Surface *tmp;

  /* Carica le texture per i mattoncini, se in alta qualità*/
  if (! opzione.lq)
  {
    if ((tmp = IMG_Load("data/brick1.png")) != NULL) if ((texture[1] = SDL_DisplayFormatAlpha(tmp)) == NULL) return false;
    if ((tmp = IMG_Load("data/brick2.png")) != NULL) if ((texture[2] = SDL_DisplayFormatAlpha(tmp)) == NULL) return false;
    if ((tmp = IMG_Load("data/brick3.png")) != NULL) if ((texture[3] = SDL_DisplayFormatAlpha(tmp)) == NULL) return false;
    if ((tmp = IMG_Load("data/gold.png")) != NULL) if ((texture[4] = SDL_DisplayFormatAlpha(tmp)) == NULL) return false;
    if ((tmp = IMG_Load("data/wall1.png")) != NULL) if ((texture[5] = SDL_DisplayFormatAlpha(tmp)) == NULL) return false;
    if ((tmp = IMG_Load("data/wall2.png")) != NULL) if ((texture[6] = SDL_DisplayFormatAlpha(tmp)) == NULL) return false;
    if ((tmp = IMG_Load("data/wall3.png")) != NULL) if ((texture[7] = SDL_DisplayFormatAlpha(tmp)) == NULL) return false;
    if ((tmp = IMG_Load("data/unbreak.png")) != NULL) if ((texture[8] = SDL_DisplayFormatAlpha(tmp)) == NULL) return false;
  }

  /* carica le icone dei bonus */
  if ((tmp = IMG_Load("data/icon.png")) != NULL) if ((icona[0] = SDL_DisplayFormatAlpha(tmp)) == NULL) return false;
  if ((tmp = IMG_Load("data/bunny.png")) != NULL) if ((icona[1] = SDL_DisplayFormatAlpha(tmp)) == NULL) return false;
  if ((tmp = IMG_Load("data/snail.png")) != NULL) if ((icona[2] = SDL_DisplayFormatAlpha(tmp)) == NULL) return false;
  if ((tmp = IMG_Load("data/bowling.png")) != NULL) if ((icona[3] = SDL_DisplayFormatAlpha(tmp)) == NULL) return false;
  if ((tmp = IMG_Load("data/dollar1.png")) != NULL) if ((icona[4] = SDL_DisplayFormatAlpha(tmp)) == NULL) return false;
  if ((tmp = IMG_Load("data/dollar2.png")) != NULL) if ((icona[5] = SDL_DisplayFormatAlpha(tmp)) == NULL) return false;
  if ((tmp = IMG_Load("data/dollar3.png")) != NULL) if ((icona[6] = SDL_DisplayFormatAlpha(tmp)) == NULL) return false;
  if ((tmp = IMG_Load("data/arrow-out.png")) != NULL) if ((icona[7] = SDL_DisplayFormatAlpha(tmp)) == NULL) return false;
  if ((tmp = IMG_Load("data/arrow-in.png")) != NULL) if ((icona[8] = SDL_DisplayFormatAlpha(tmp)) == NULL) return false;
  if ((tmp = IMG_Load("data/heart.png")) != NULL) if ((icona[9] = SDL_DisplayFormatAlpha(tmp)) == NULL) return false;
  if ((tmp = IMG_Load("data/missle.png")) != NULL) if ((icona[10] = SDL_DisplayFormatAlpha(tmp)) == NULL) return false;
  if ((tmp = IMG_Load("data/sheep.png")) != NULL) if ((icona[11] = SDL_DisplayFormatAlpha(tmp)) == NULL) return false;
  if ((tmp = IMG_Load("data/theboss.png")) != NULL) if ((icona[12] = SDL_DisplayFormatAlpha(tmp)) == NULL) return false;
  if ((tmp = IMG_Load("data/rain.png")) != NULL) if ((icona[13] = SDL_DisplayFormatAlpha(tmp)) == NULL) return false;

  SDL_FreeSurface(tmp);
  return true;
}

bool mouse(bool visibile)
{
  bool r = true;
  if (! visibile)
  {
    if (opzione.grabmouse) if (SDL_WM_GrabInput(SDL_GRAB_ON) != SDL_GRAB_ON) r = false;
    if (SDL_ShowCursor(SDL_DISABLE) != SDL_DISABLE) r = false;
  }
  else
  {
    if (opzione.grabmouse) if (SDL_WM_GrabInput(SDL_GRAB_OFF) != SDL_GRAB_OFF) r = false;
    if (SDL_ShowCursor(SDL_ENABLE) != SDL_ENABLE) r = false;
  }
  return r;
}
