struct angolo {
  double sin, cos;
};

/* Opzioni di gioco */
struct opt {
  unsigned int startLvl;  // Livello di partenza
  Uint8 difficolta;       // difficoltà di gioco
  bool sonoro;            // suono sì/no
  bool autosave;          // Salvataggio automatico
  int8_t volumeEffetti;   // Volume degli effetti sonori (bip, bump, click, ecc..)
  int8_t volumeMusica;    // Volume della musica (intro e background)
  bool mouse;             // Attiva/disattiva controllo con mouse
  bool panscan;           // panscan=true modalità 4:3 (invece di 16:9)
  int maxfps;             // Max frame per second
  bool fullscreen;        // Schermointero sì/no
  bool lq;                // low quality yes/no
  bool grabmouse;         // assume il controllo completo del mouse sì/no
};

/* Dati sulla partita */
struct infopartita {
  short bonus_percent;    // frequenza con cui cadono i bonus in percentuale%
  short activeBalls;      // numero di palle attive
  short fpscount;         // Contatore frame per secondo ++
  short cfps;             // Current Frame per Second
};

infopartita gameinfo;

/* === Se si aggiungono dei nuovi blocchi, aggiornare anche la dimensione
 * dell'array nel file 'livelli.cpp' [N_RAND_BLOCKS dovrebbe risolvere il problema]=== */
/* Codici dei 15 blocchi utilizzabili */
#define blocktype0 0x00   // Vuoto - void
#define blocktype1 0x09   // vuoto - void
#define blocktype2 0x0A   // 10pt
#define blocktype3 0x0B   // 5pt rosso
#define blocktype4 0x0C   // 5pt blu
#define blocktype5 0x0D   // 30pt Gold
#define blocktype6 0x80   // Rallenty
#define blocktype7 0x81   // Speed up
#define blocktype8 0x82   // Paddle++
#define blocktype9 0x83   // Paddle--
#define blocktype10 0x8C  // Extralife
#define blocktype11 0x96  // The Boss 200pt
#define blocktype12 0x97  // Indistruttibile grigio
#define blocktype13 0x98  // Uggioso2
#define blocktype14 0x99  // Uggioso1
#define blocktype15 0x9A  // Uggioso
#define blocktype16 0xC8  // Palla trapassa
#define blocktype17 0xC9  // Missile
#define blocktype18 0xCA  // Sdoppiamento palla
#define blocktype19 0xCB  // Pioggia di bonus
/* Array dove 'pesca' blocchi random (scelti tra quelli esistenti sopra) */
#define N_RAND_BLOCKS 14
const unsigned char blockRandomTypes[N_RAND_BLOCKS] = {0x0C, 0x0D, 0x80, 0x81, 0x82, 0x83, 0x8C, 0xCA, 0x97, 0xC8, 0x96, 0xCB, 0xC9, 0x0C};

struct tempi {
  long bonus;
  long missile;
  long iconfade;
};

tempi lasttime;

